# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------
from azureml._base_sdk_common.user_agent import get_user_agent
from msrest.service_client import SDKClient
from msrest import Configuration, Serializer, Deserializer
from .exceptions import wrap_api_caller_methods_with_error_handling
from .operations.component_operations import ComponentOperations
from .operations.computes_operations import ComputesOperations
from .operations.data_sets_operations import DataSetsOperations
from .operations.experiments_operations import ExperimentsOperations
from .operations.module_operations import ModuleOperations
from .operations.modules_operations import ModulesOperations
from .operations.module_with_auth_operations import ModuleWithAuthOperations
from .operations.pipeline_drafts_operations import PipelineDraftsOperations
from .operations.pipeline_endpoints_operations import PipelineEndpointsOperations
from .operations.pipeline_runs_operations import PipelineRunsOperations
from .operations.published_pipelines_operations import PublishedPipelinesOperations
from .operations.real_time_endpoints_operations import RealTimeEndpointsOperations
from .operations.runs_operations import RunsOperations
from .operations.samples_operations import SamplesOperations
from . import models
from ..._version import VERSION


class DesignerServiceClientConfiguration(Configuration):
    """Configuration for DesignerServiceClient
    Note that all parameters used to create this instance are saved as instance
    attributes.

    :param str base_url: Service URL
    """

    def __init__(
            self, base_url=None):
        if not base_url:
            base_url = 'http://localhost'

        super(DesignerServiceClientConfiguration, self).__init__(base_url)
        # timeout for http caller to 200s since MT timeout is 180s
        # TODO: verify if this works
        self.connection.timeout = 200
        self.add_user_agent('designerserviceclient/{}'.format(VERSION))
        # add user-agent with all azureml packages and versions, eg: azureml-sdk-core/0.1.0.0 azureml-cli/0.1.0.0
        self.add_user_agent(get_user_agent())


class DesignerServiceClient(SDKClient):
    """DesignerServiceClient

    :ivar config: Configuration for client.
    :vartype config: DesignerServiceClientConfiguration

    :ivar component: Component operations
    :vartype component: designer.operations.ComponentOperations
    :ivar computes: Computes operations
    :vartype computes: designer.operations.ComputesOperations
    :ivar data_sets: DataSets operations
    :vartype data_sets: designer.operations.DataSetsOperations
    :ivar experiments: Experiments operations
    :vartype experiments: designer.operations.ExperimentsOperations
    :ivar module: Module operations
    :vartype module: designer.operations.ModuleOperations
    :ivar modules: Modules operations
    :vartype modules: designer.operations.ModulesOperations
    :ivar module_with_auth: ModuleWithAuth operations
    :vartype module_with_auth: designer.operations.ModuleWithAuthOperations
    :ivar pipeline_drafts: PipelineDrafts operations
    :vartype pipeline_drafts: designer.operations.PipelineDraftsOperations
    :ivar pipeline_endpoints: PipelineEndpoints operations
    :vartype pipeline_endpoints: designer.operations.PipelineEndpointsOperations
    :ivar pipeline_runs: PipelineRuns operations
    :vartype pipeline_runs: designer.operations.PipelineRunsOperations
    :ivar published_pipelines: PublishedPipelines operations
    :vartype published_pipelines: designer.operations.PublishedPipelinesOperations
    :ivar real_time_endpoints: RealTimeEndpoints operations
    :vartype real_time_endpoints: designer.operations.RealTimeEndpointsOperations
    :ivar runs: Runs operations
    :vartype runs: designer.operations.RunsOperations
    :ivar samples: Samples operations
    :vartype samples: designer.operations.SamplesOperations

    :param str base_url: Service URL
    """

    def __init__(
            self, base_url=None):
        self.config = DesignerServiceClientConfiguration(base_url)
        super(DesignerServiceClient, self).__init__(None, self.config)

        client_models = {k: v for k, v in models.__dict__.items() if isinstance(v, type)}
        self.api_version = '1.0.0'
        self._serialize = Serializer(client_models)
        self._deserialize = Deserializer(client_models)

        # follow azureml._restclient.clientbase.ClientBase's startegy to override
        def pretty_print(self):
            import json
            from azureml._restclient.clientbase import _ErrorEncoder
            return json.dumps(self, indent=4, cls=_ErrorEncoder)

        from azure.ml.component._restclients.designer.models import (DebugInfoResponse, InnerErrorResponse, RootError,
                                                                     ErrorResponse)
        classes_to_pretty_print = [DebugInfoResponse, InnerErrorResponse, RootError, ErrorResponse]
        for class_to_pretty_print in classes_to_pretty_print:
            class_to_pretty_print.__str__ = class_to_pretty_print.__repr__ = pretty_print

        def create_operation(operation_class):
            instance = operation_class(self._client, self.config, self._serialize, self._deserialize)
            wrap_api_caller_methods_with_error_handling(instance)
            return instance

        self.component = create_operation(ComponentOperations)

        self.computes = create_operation(ComputesOperations)

        self.data_sets = create_operation(DataSetsOperations)

        self.experiments = create_operation(ExperimentsOperations)

        self.module = create_operation(ModuleOperations)

        self.modules = create_operation(ModulesOperations)

        self.module_with_auth = create_operation(ModuleWithAuthOperations)

        self.pipeline_drafts = create_operation(PipelineDraftsOperations)

        self.pipeline_endpoints = create_operation(PipelineEndpointsOperations)

        self.pipeline_runs = create_operation(PipelineRunsOperations)

        self.published_pipelines = create_operation(PublishedPipelinesOperations)

        self.real_time_endpoints = create_operation(RealTimeEndpointsOperations)

        self.runs = create_operation(RunsOperations)

        self.samples = create_operation(SamplesOperations)
